module cache_coherence_tb;
reg RMS, RME, WM, WH, RH, SHR, SHW, clk, READ_DONE , reset,send_abort, write_back_done, AllInvDone, PA, PB, countE;
reg [2:0] state, SectorInCacheA, SectorInCacheB;
reg [3:0] count;

wire [2:0] new_state;
wire Cache_Sector_Fill, Invalidate, AdrRetry;
cache_coherence uut (.new_state(new_state), .Cache_Sector_Fill(Cache_Sector_Fill), .Invalidate(Invalidate), .AdrRetry(AdrRetry), .RMS(RMS), .RME(RME), .WM(WM), .WH(WH), .SHR(SHR), .SHW(SHW), .state(state), .READ_DONE(READ_DONE), .clk(clk), .reset(reset), .send_abort(send_abort), .write_back_done(write_back_done), .AllInvDone(AllInvDone));
initial
begin
/* The states of sector in both caches are initialized to Invalid (0). */
SectorInCacheA = 0; SectorInCacheB = 0;
/* Signals set/rest by cache controller */
// Write Hit
WH = 0;
// ReadMiss (Shared)
RMS = 0;
// WriteMiss
WM  = 0;
// Snoop hit on read operation
SHR = 0;
// Snoop hit on write operation
SHW = 0;

READ_DONE = 0;

AllInvDone = 0;

write_back_done = 0;

send_abort = 0;
state = SectorInCacheA ; PA = 1; PB = 0; RME = 1;
reset = 1; #6 reset = 0;

#40 PA = 0; PB = 1; RME = 0; RMS = 1; state = SectorInCacheB;
reset = 1;#10 reset = 0;
#50 PB = 0; PA = 1; SHR = 1; state = SectorInCacheA;
reset = 1; #10 reset = 0;
#20 SHR = 0; WH = 1; state = SectorInCacheA;
reset = 1; #10 reset = 0;
#50 PA = 0; PB = 1; RMS = 1; WH = 0; state = SectorInCacheB;
reset = 1; #10 reset = 0;
#30 SHR = 1; RMS = 0; PA = 1; PB = 0; state = SectorInCacheA;
reset = 1; #10 reset = 0;
#20 PB = 1; PA = 0; SHR = 0; state = SectorInCacheB;
reset = 1; #10 reset = 0;
// PA states writing back.
#20 PB = 0; PA = 1; state = SectorInCacheA;
reset = 1; #10 reset = 0;
#30 write_back_done = 1;
#10 write_back_done = 0;
// PB retry.
#10 PA = 0; PB = 1; RMS = 1; state = SectorInCacheB;
reset = 1; #10 reset = 0;
// #100 $stop;
// #100 $finish;
end
always @(new_state)
begin
if (PA == 1) SectorInCacheA = new_state ;
else if (PB == 1) SectorInCacheB = new_state ;
end
always @(posedge clk)
begin
if (Invalidate)
begin
#10 SectorInCacheB = 0;
#10 AllInvDone = 1;
#15 AllInvDone = 0;
end
else if (Cache_Sector_Fill)
begin
count = 0;
countE = 1;
        // Intialize the Read_Done variable to 0;
READ_DONE = 0;
end
else if (AdrRetry)
begin
countE = 0;
send_abort = 1;
#40 send_abort = 0;
end
end
always @(posedge clk)
begin
if (READ_DONE == 1) READ_DONE = 0;
if (countE == 1)
begin
if ( count == 2 )
begin
READ_DONE = 1;
countE = 0;
end
else count = count + 1;
end
end
initial clk = 0;
always #5 clk = ~clk ;

endmodule 

