module cache_controller_tb;
reg clk;
reg [6:0] tag;                //tag field
reg [5:0] index;             //cache line
reg wr_en;                 //write/read signal (1,0)
reg flush;                //reset cache - set all valid bits to zero
reg ready;               //data block ready sig from memory
wire stall;                //stall the processor (1,0)
wire wr_en_mem;           //write/read signal to memory (1,0)
wire update_cache;          //update data array
wire cache_hit;

cache_controller uut(.clk(clk),.tag(tag),.index(index),.wr_en(wr_en),.flush(flush),.ready(ready),.stall(stall),.wr_en_mem(wr_en_mem),.update_cache(update_cache),.cache_hit(cache_hit));
initial begin
clk=1'b0;
wr_en=1'b1;
ready=1'b1;
tag=7'h00;
index=6'h01;
#10 
tag=7'h24;
index=6'h02;
#10 
tag=7'h26;
index=6'h45;
#10
tag=7'h56;
index=6'h08;
#10
wr_en=1'b0;
tag=7'h00;
index=6'h01;
#10
tag=7'h24;
index=6'h02;
#10
tag=7'h26;
index=6'h45;
#10
tag=7'h56;
index=6'h08;
#10 flush=1'b1;
end
always #5 clk=~clk;
endmodule


