module page_table(
input clock,
input [21:0] VPN,
output reg [19:0] PPN_o,
output reg valid_o
  );

parameter PTE_ENTRIES = 4194304;

reg [31:0] PPN [PTE_ENTRIES-1:0];
reg valid [PTE_ENTRIES-1:0];
 
integer i;
integer ppn_curr;

initial begin
 ppn_curr = 4194304;
   for(i = 0; i < 4194304 ; i = i + 1)                                                                                     
     begin                                                                                                               
       if(i<4194286)
         begin  
           valid[i]=1'b1;
           PPN[i] = { i % 1048576 +1'b1 };  
         end
       else 
         begin 
           valid[i]=1'b0;
           PPN[i] = { i % 1048576 +1'b1};  
         end 
              
         end   
      end
    
   always @(posedge clock) begin
        if(valid[VPN])begin 
            PPN_o=PPN[VPN];
            valid_o=valid[VPN];
        end else begin 
            PPN[VPN]=ppn_curr;
            valid[VPN]=1'b1;
            PPN_o=PPN[VPN];
            
            
            
            ppn_curr=ppn_curr+1;//PPN_curr++
        end
    end

    
endmodule
