module page_table_tb();
    reg 		clk;
    reg 		tlb_en;
    reg 		read_write;
    wire 		tlb_hit;
    wire 		hit_miss;
    reg 		clear_refer;
    reg    [33:0] 	_address2;
    reg    [31:0]       din;
    wire   [31:0]	PA;

 integer time_curr=0;
    
    TLB tlb(clk,
	tlb_en,
        read_write,
	clear_refer,
	_address2,//virtual address
	PA,//PYHSICAL ADDRESS
	
	tlb_hit
    );

    data_cache cache(clk,
          _address,    // address form CPU
          _address2,
          din,        // data from CPU (if st inst)
          rden,       // 1 if ld instruction
          wren,       // 1 if st instruction
          hit_miss,   // 1 if hit, 0 while handling miss
          q,          // data from cache to CPU
          mdout,      // data from cache to memory
          mrdaddress, // memory read address
          mrden,      // read enable, 1 if reading from memory
          mwraddress, // memory write address
          mwren,      // write enable, 1 if writing to memory
          mq          // data coming from memory
     );

always #5 clk = ~clk;
always #5 time_curr =time_curr+5;
    initial 
    begin
        clk=1'b1;
	tlb_en=1'b1;
        clear_refer=1'b0;
    assign clear_refer= (time_curr /(16*10))%2;
	   #10 read_write = 0; _address2 = 34'h0;  //should miss
	   
	   #10 read_write = 1; _address2 = 34'h0; din = 32'h11111111; //should hit
	   
	   #10 read_write = 0; _address2 = 34'h0; //should hit and read out 0xff
	   
	   
	   #10 read_write = 0; _address2 = 34'h200; //should miss
	   
	   #10 read_write = 0; _address2 = 34'h0; //should hit 
	   
	   #10 read_write = 0; _address2 = 34'h300; //should miss
	   
	   #10 read_write = 0; _address2 = 34'h200; //should miss
	   	
	   #10 read_write = 0; _address2 = 34'h240; //should miss
	   
	   #10 read_write = 0; _address2 = 34'h50; 
	   
	   #10 read_write = 0; _address2 = 34'h360; //should miss
	   
	   #10 read_write = 0; _address2 = 34'h270;
	   	   
	   #10  read_write = 0; _address2 = 34'h80;  
	   
	   #10  read_write = 1; _address2 = 34'h90; din = 32'h11111111; 
	   
	   #10  read_write = 0; _address2 = 34'hA0; //should hit 
	   	
	   #10  read_write = 0; _address2 = 34'h2B0; //should miss
	  
	   #10  read_write = 0; _address2 = 34'hC0; 
	   
	   #10  read_write = 0; _address2 = 34'h3D0; //should miss
	   
	   #10  read_write = 0; _address2 = 34'h2E0; 
	   
	   #10  read_write = 0; _address2 = 34'hF0;  
	   
	   #10  read_write = 1; _address2 = 34'h100; din = 32'h11111111; 
	   
	   #10  read_write = 0; _address2 = 34'h110; //should hit 
	  	
	   #10 read_write = 0; _address2 = 34'h200; 
	   
	   #10 read_write = 0; _address2 = 34'h0; 
	   
	   #10 read_write = 0; _address2 = 34'h300; 
	   
	   #10 read_write = 0; _address2 = 34'h200; 
	  

end

endmodule