`include "page_table.v"
 module tlb(
  input clock,
  input tlb_en,
  input clear_refer,
  input [33:0] VA,//virtual address
  output reg [31:0] PA,//PYHSICAL ADDRESS
  //input [16:0] PT_DATA
  output reg tlb_hit
);


 reg [19:0] PPN [52:0];
 reg [21:0] VPN [52:0]; 
 reg refer [52:0];
 reg valid [52:0];
 integer i=0;
 reg [2:0] visit_entry;

 wire [11:0]_VA = VA[11:0];	
 wire [19:0] page_table_PPN_out;
 wire  page_table_valid_out;
 page_table pt(clock,VA[33:12],page_table_PPN_out,page_table_valid_out);

 initial
   begin
      VPN[0]=22'b0101001010001110100101;
      PPN[0]=20'b01001010001110100110;
      VPN[1]=22'b1010001110101110101011;
      PPN[1]=20'b10001110101110101100;
      VPN[2]=22'b0000101111111111111111;
      PPN[2]=20'b00110000000000000000;
      VPN[3]=22'b0101111000001010010101;
      PPN[3]=20'b01111000001010010110;
      VPN[4]=22'b1101011010001010001011;
      PPN[4]=20'b01011010001010001100;
      VPN[5]=22'b0001101001111100010101;
      PPN[5]=20'b01101001111100010110;
      VPN[6]=22'b0010100101111110000011;
      PPN[6]=20'b10100101111110000100;
      VPN[7]=22'b1101011010000101111111;
      PPN[7]=20'b01011010000110000000;
   end
 always @(posedge clock) begin
    if(tlb_en) begin
      /*if(clear_refer) begin
        for(i=0; i<8; i=i+1)
          begin
         	  refer[i] <= 1'b0;
 	end
      end
    for(i = 0 ;i < 7; i = i + 1) begin
      if (VA[33:12]==VPN[i]) begin
	  tlb_hit <= 1;
	  visit_entry <= i;
        end
	 else tlb_hit <= 0;
      end
  end*/
      case(i)
        0: begin
             if(clear_refer)
               begin
                 refer[i] <= 1'b0;
                 i <= i+1;
               end
             else 
               begin
                 refer[i] <= 1'b1;
                 i <= i+1;
               end
             if(VA[33:12] == VPN[i])
               begin
                 tlb_hit <= 1;
                 visit_entry <= i;
               end
             else tlb_hit <= 0;
           end
        1: begin
             if(clear_refer)
               begin
                 refer[i] <= 1'b0;
                 i <= i+1;
               end
             else 
               begin
                 refer[i] <= 1'b1;
                 i <= i+1;
               end
             if(VA[33:12] == VPN[i])
               begin
                 tlb_hit = 1;
                 visit_entry = i;
               end
             else tlb_hit = 0;
           end
        2: begin
             if(clear_refer)
               begin
                 refer[i] <= 1'b0;
                 i <= i+1;
               end
             else 
               begin
                 refer[i] <= 1'b1;
                 i <= i+1;
               end
           if(VA[33:12] == VPN[i])
               begin
                 tlb_hit <= 1;
                 visit_entry <= i;
               end
           else tlb_hit <= 0;
           end
        3: begin
             if(clear_refer)
               begin
                 refer[i] <= 1'b0;
                 i <= i+1;
               end
             else 
               begin
                 refer[i] <= 1'b1;
                 i <= i+1;
               end
             if(VA[33:12] == VPN[i])
               begin
                 tlb_hit <= 1;
                 visit_entry <= i;
               end
             else tlb_hit <= 0;
           end
        4: begin
             if(clear_refer)
               begin
                 refer[i] <= 1'b0;
                 i <= i+1;
               end
             else 
               begin
                 refer[i] <= 1'b1;
                 i <= i+1;
               end
             if(VA[33:12] == VPN[i])
               begin
                 tlb_hit <= 1;
                 visit_entry <= i;
                 end
             else tlb_hit <= 0;
           end
        5: begin
             if(clear_refer)
               begin
                 refer[i] <= 1'b0;
                 i <= i+1;
               end
             else 
               begin
                 refer[i] <= 1'b1;
                 i <= i+1;
               end
             if(VA[33:12] == VPN[i])
               begin
                 tlb_hit <= 1;
                 visit_entry <= i;
               end
             else tlb_hit <= 0;
           end
        6: begin
             if(clear_refer)
               begin
                 refer[i] <= 1'b0;
                 i <= i+1;
               end
             else 
               begin
                 refer[i] <= 1'b1;
                 i <= i+1;
               end
             if(VA[33:12] == VPN[i])
               begin
                 tlb_hit <= 1;
                 visit_entry <= i;
               end
             else tlb_hit <= 0;
           end
        7: begin
             if(clear_refer) refer[i] <= 1'b0;
             else refer[i] <= 1'b1;
             if(VA[33:12] == VPN[i])
               begin
                 tlb_hit <= 1;
                 visit_entry <= i;
               end
             else tlb_hit <= 0;
           end
        default: tlb_hit = 1'bx;
      endcase

   case(i)
     0: begin
          if(tlb_hit)
            begin
              #10 PA = {PPN[visit_entry],_VA[11:0]};
              refer[visit_entry] <= 1;
            end
          else
            begin
              if(refer[i]==0) begin 
                visit_entry = i; end
                valid[visit_entry]=page_table_valid_out;
                #10 PA = {page_table_PPN_out,_VA[11:0]};
                refer[visit_entry] = 1;
               end
            end
     1: begin
          if(tlb_hit)
            begin
              #10  PA = {PPN[visit_entry],_VA[11:0]};
              refer[visit_entry] = 1;
            end
          else
            begin
              if(refer[i]==0) begin
                visit_entry = i; end
                valid[visit_entry]=page_table_valid_out;
                #10 PA = {page_table_PPN_out,_VA[11:0]};
                refer[visit_entry] = 1;
             end
         end
     2: begin
          if(tlb_hit)
            begin
              #10 PA = {PPN[visit_entry],_VA[11:0]};
              refer[visit_entry] = 1;
            end
         else
           begin
             if(refer[i]==0) begin
               visit_entry = i; end
               valid[visit_entry]=page_table_valid_out;
              #10 PA = {page_table_PPN_out,_VA[11:0]};
              refer[visit_entry] = 1;
           end
        end
     3: begin
          if(tlb_hit)
             begin
               #10 PA <= {PPN[visit_entry],_VA[11:0]};
               refer[visit_entry] <= 1;
             end
          else
            begin
              if(refer[i]==0) begin
                visit_entry <= i; end
                valid[visit_entry]<=page_table_valid_out;
                #10 PA <= {page_table_PPN_out,_VA[11:0]};
                refer[visit_entry] <= 1;
            end
        end
     4: begin
          if(tlb_hit)
            begin
              #10 PA <= {PPN[visit_entry],VA[11:0]};
              refer[visit_entry] <= 1;
            end
          else
            begin
              if(refer[i]==0) begin
                visit_entry <= i; end
                valid[visit_entry]<=page_table_valid_out;
                #10 PA <= {page_table_PPN_out,VA[11:0]};
                refer[visit_entry] <= 1;
            end
        end
     5: begin
          if(tlb_hit)
            begin
              #10 PA <= {PPN[visit_entry],VA[11:0]};
              refer[visit_entry] <= 1;
            end
          else
            begin
              if(refer[i]==0) begin
                visit_entry <= i; end
                valid[visit_entry]<=page_table_valid_out;
                #10 PA <= {page_table_PPN_out,VA[11:0]};
                refer[visit_entry] <= 1;
            end
         end
     6: begin
          if(tlb_hit)
            begin
              #10 PA <= {PPN[visit_entry],VA[11:0]};
              refer[visit_entry] <= 1;
            end
          else
            begin
              if(refer[i]==0) begin
                visit_entry <= i; end
                valid[visit_entry]<=page_table_valid_out;
                #10 PA <= {page_table_PPN_out,VA[11:0]};
                refer[visit_entry] <= 1;
            end
         end
     7: begin
          if(tlb_hit)
            begin
              #10 PA = {PPN[visit_entry],VA[11:0]};
              refer[visit_entry] = 1;
            end
          else
            begin
              if(refer[i]==0) begin
                visit_entry = i; end
                #10 PA = {page_table_PPN_out,VA[11:0]};
                valid[visit_entry]=page_table_valid_out;
                refer[visit_entry] = 1;
            end
          end
       default: #10 PA <= 32'bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx;
     endcase
   end
 end
endmodule
