module Control_Unit(Opcode,RegWrite,MemWrite,Result_Select,Branch,Jump,Rs2_Select);
//Declaring Inputs and Outputs
    input [6:0]Opcode;
    output RegWrite,MemWrite,Result_Select,Branch,Jump,Rs2_Select;


    assign RegWrite = (Opcode == 7'b0000011 || Opcode == 7'b0110011 || Opcode == 7'b0010011 || Opcode == 7'b0110111 || Opcode == 7'b0010111 || Opcode == 7'b1101111 || Opcode == 7'b1100111) ? 1'b1 :
                                                                                              1'b0 ;
    assign MemWrite = (Opcode == 7'b0100011) ? 1'b1 :
                                               1'b0 ;
    assign Result_Select = (Opcode == 7'b0000011) ? 1'b1 :
                                                    1'b0 ;
    assign Branch = (Opcode == 7'b1100011) ? 1'b1 :
                                             1'b0 ;
    assign Jump = (Opcode == 7'b1101111 || Opcode == 7'b1100111)? 1'b1 : 1'b0; 

    assign Rs2_Select = (Opcode == 7'b0010011 || Opcode == 7'b0000011 || Opcode == 7'b0100011 || Opcode == 7'b0110111 |
                         Opcode == 7'b0010111 || Opcode == 7'b1101111 || Opcode == 7'b1100111)? 1'b1 : 1'b0 ;
endmodule 