//IF_ID_Stage
module Fetch_cycle(enable,clk, rst, enable, clear_d, PC_Select_E, PCTarget_E, Instruction_D, PC_D);
  // Declare input & outputs
//    input [31:0]instruction_fetch;
   // input Instruction_enable;
    input clk, rst;
    input enable, clear_d;
    input PC_Select_E;
    input [31:0] PCTarget_E;
    output [31:0] Instruction_D;
    output [31:0] PC_D;

  // Declaring interim wires
    wire [31:0] PC_F, PCF, PCPlus4F;
    wire [31:0] Instruction_F;
    wire [31:0] PC_F_reg_temp = 0, Instruction_F_reg_temp = 0;

  // Declaration of Register
    reg [31:0] Instruction_F_reg;
    reg [31:0] PC_F_reg;


  // Initiation of Modules
   // Declare PC Mux
    mux2_1 PC_MUX (.a(PCPlus4F),
                   .b(PCTarget_E),
                   .s(PC_Select_E),
                   .y(PCF)
                  );

   // Declare PC Counter
    Program_Counter Program_Counter (.clk(clk),
                                     .rst(rst),
                                     .enable(enable),
                                     .PC(PC_F),
                                     .PC_Next(PCF)
                                    );

   // Declare Instruction Memory
    Instruction_Memory IMem(//.clk(clk),
	               		    .rst(rst),
			             //   .Instruction_enable(Instruction_enable),
//			    			.instruction_fetch(instruction_fetch),
                            .A(PC_F),
                            .RD(Instruction_F)
                           );

   // Declare PC adder
    PC_Adder PC_adder(.a(PC_F),
                      .b(32'h00000004),
                      .y(PCPlus4F)
                     );

  // Fetch Cycle Register Logic
    always @(posedge clk or posedge rst) 
    begin
        if(rst == 1'b1) 
         begin
            Instruction_F_reg <= 32'h00000000;
            PC_F_reg <= 32'h00000000;
         end
	else if(clear_d) //Control Hazard
         begin
          Instruction_F_reg <= 32'b0000000_00000_00000_000_00000_0110011; // dummy innstruction
          PC_F_reg <= 10'bxxxxxxxxxx; // dummy instrction indicated  by x  - ( nop) 
         end
        else if(enable)
         begin
          PC_F_reg <=PC_F_reg_temp; // loop back
          Instruction_F_reg <= Instruction_F_reg_temp; // loop back
         end
        else 
         begin
            Instruction_F_reg <= Instruction_F;
            PC_F_reg <= PC_F;
         end
    end

  // Assigning Registers Value to the Output port
    assign  Instruction_D = Instruction_F_reg;
    assign  PC_D = PC_F_reg;
endmodule 