module Hazardunit(enable, clear, clear_d , ForwardA_E, ForwardB_E,opcode_D,opcode_E, RS1_D, RS2_D, RD_E,
RS1_E,RS2_E, RD_M, RD_W, RegWrite_M, RegWrite_W, Result_Select_E, PC_Select_E);

  input [6:0] opcode_D,opcode_E;
  input [4:0] RS1_E, RS2_E,RD_E, RD_M,RD_W, RS1_D,RS2_D;
  input RegWrite_M, RegWrite_W,Result_Select_E, PC_Select_E;
  output reg enable, clear,clear_d;
  output reg [1:0] ForwardA_E, ForwardB_E;
  parameter [6:0]r_to_r = 7'b0110011,
		r_to_imm = 7'b0010011,
               ld            = 7'b0000011,
               store         = 7'b010001,
               branch        = 7'b1100011,
               lui           = 7'b0110111,
               auipc         = 7'b0010111,
               jal           = 7'b1101111,
               jalr          = 7'b1100111;


  always @(*)
   begin
   // control hazard used for fulsing the ooperation
     if(PC_Select_E)
     begin
      clear <= 1'b1;
      clear_d <= 1'b1;//control hazard
      enable <=1'b0;
      ForwardA_E <= 2'b00;
      ForwardB_E <= 2'b00;
     end
//DATA HAZARD WHEN THERE IS A LOAD TYPE INSTRUCTION

    else if( ( RS1_D == RD_E && opcode_D !=lui && opcode_D != auipc && opcode_D != jal) && Result_Select_E == 1'b1)
     begin
      enable <= 1'b1;
      clear  <= 1'b1;
      clear_d <= 1'b0;
      ForwardA_E <= 2'b00;
      ForwardB_E <= 2'b00;
     end

else if( ((RS2_D == RD_E )&& (opcode_D == store || opcode_D == branch || opcode_D == r_to_r)) && Result_Select_E == 1'b1)
     begin
      enable <= 1'b1;
      clear  <= 1'b1;
      clear_d <= 1'b0;
      ForwardA_E <= 2'b00;
      ForwardB_E <= 2'b00;
     end

    else if( ( (RS1_E == RD_M) && RegWrite_M) && opcode_E !=lui && opcode_E != auipc && opcode_E != jal )
     begin
      enable <= 1'b0;
      ForwardA_E <= 2'b01;
      ForwardB_E <= 2'b00;
      clear  <= 1'b0;
      clear_d <= 1'b0;
     end
    else if( ( (RS1_E == RD_W) && RegWrite_W) && opcode_E !=lui && opcode_E != auipc && opcode_E != jal)
     begin
      enable <= 1'b0;
      ForwardA_E <= 2'b10;
      ForwardB_E <= 2'b00;
      clear  <= 1'b0;
      clear_d <= 1'b0;
     end
    else if(( (RS2_E == RD_M) && RegWrite_M) && (opcode_E == store || opcode_E == branch || opcode_E == r_to_r))
     begin
      enable <= 1'b0;
      ForwardA_E <= 2'b00;
      ForwardB_E <= 2'b01;
      clear  <= 1'b0;
      clear_d <= 1'b0;
     end
    else if (( (RS2_E == RD_W) && RegWrite_W) && (opcode_E == store || opcode_E == branch || opcode_E == r_to_r))
     begin
      enable <= 1'b0;
      ForwardA_E <= 2'b00;
      ForwardB_E <= 2'b10;
      clear  <= 1'b0;
      clear_d <= 1'b0;
     end
    else
     begin
      enable <= 1'b0;
      ForwardA_E <= 2'b00;
      ForwardB_E <= 2'b00;
      clear  <= 1'b0;
      clear_d <= 1'b0;
     end
   end
endmodule 