module Pipeline_tb();
reg clk, rst;
integer k,l;

Pipeline riscv(.clk(clk),.rst(rst));

initial
 begin
     rst= 1;
  #2 rst = 0; 
     repeat (20)
     begin
      #5 clk=0;#5 clk=1;  
     end
 end

initial
 begin
  for (k=0; k<31; k=k+1)
   begin
    riscv.Decode.Registers.Register[k] = k;
   end
  for (l = 0; l <1024 ; l = l+1)
   begin
    riscv.Memory.Data_Memory.mem[l] = l;
   end
 end

 initial begin
 /*
//Control and data
//riscv.PC_Reg = 10'b0;
 riscv.Fetch.IMem.Mem[0]   = 32'h00208AB3; // ADD X21 X1 X2
 riscv.Fetch.IMem.Mem[4]   = 32'h00B08113; // ADDI X2 X1 11
 riscv.Fetch.IMem.Mem[8]   = 32'h015A49B3; // XOR X19 X20 X21
 riscv.Fetch.IMem.Mem[12]  = 32'hFE059AE3; // BNE X13 X0 -12
 riscv.Fetch.IMem.Mem[16]  = 32'h41078733; // SUB  X14, X15, X16
*/

/*
//Signed and Unsigned
 riscv.Fetch.IMem.Mem[0]     = 32'hFFF4A513; // SLTI  X10,X9,-1
 riscv.Fetch.IMem.Mem[4]     = 32'hFFF4B513; // SLTUI X10,X9,-1
*/

/*
riscv.Fetch.IMem.Mem[0]    = 32'h00158693; // ADDI X13, X11,1
riscv.Fetch.IMem.Mem[4]    = 32'h41078733; // SUB  X14, X15, X16
riscv.Fetch.IMem.Mem[8]    = 32'hC2211363; // BEQ  X0, X0, 0
riscv.Fetch.IMem.Mem[12]   = 32'h0128F833; // AND  X16, X17, X18
riscv.Fetch.IMem.Mem[16]   = 32'h015A49B3; // XOR  X19, X20, X21
*/
/*
riscv.Fetch.IMem.Mem[0]     = 32'h00108113; // ADDI  X2,X1,1
riscv.Fetch.IMem.Mem[4]     = 32'h00508167; // JALR  X2,X1,5
*/
/*
riscv.Fetch.IMem.Mem[0]     = 32'h00108113; // ADDI  X2,X1,1
riscv.Fetch.IMem.Mem[4]     = 32'h22200CEF; // JAL   X25,0X00000111
*/
/*
riscv.Fetch.IMem.Mem[0]     = 32'h00108113; // ADDI  X2,X1,1
riscv.Fetch.IMem.Mem[4]     = 32'h12346B17; // AUIPC X22,12346
*/

/*
riscv.Fetch.IMem.Mem[0]     = 32'h00108113; // ADDI  X2,X1,1
riscv.Fetch.IMem.Mem[4]     = 32'h12345B37; // LUI   X22,12345

/*
//Store, R, Load
 //riscv.PCF = 32'h00000000;
 riscv.Fetch.IMem.Mem[0]     = 32'h01508123; // SB   X21,X1,2
 riscv.Fetch.IMem.Mem[4]     = 32'h01619223; // SH   X22,X3,4
 riscv.Fetch.IMem.Mem[8]     = 32'h0172A323; // SW   X23,X5,6
 riscv.Fetch.IMem.Mem[12]    = 32'h0083AC33; // SLT  X24,X7,8
 riscv.Fetch.IMem.Mem[16]    = 32'h00A4BCB3; // SLTU X25,X9,10
 riscv.Fetch.IMem.Mem[20]    = 32'h00C5CD33; // XOR  X26,X11,12
 riscv.Fetch.IMem.Mem[24]    = 32'h00E6DDB3; // SRL  X27,X13,14
 riscv.Fetch.IMem.Mem[28]    = 32'h4107DE33; // SRA  X28,X15,16
 riscv.Fetch.IMem.Mem[32]    = 32'h0128EEB3; // OR   X29,X17,18
 riscv.Fetch.IMem.Mem[36]    = 32'h0149FF33; // AND  X30,X19,20
 riscv.Fetch.IMem.Mem[40]    = 32'h00110083; // LB   X1,X2,1
 riscv.Fetch.IMem.Mem[44]    = 32'h00321183; // LH   X3,X4,3
 riscv.Fetch.IMem.Mem[48]    = 32'h00532283; // LW   X5,X6,5
*/
/*
//LOAD TYPE
 riscv.Fetch.IMem.Mem[0]      = 32'h00110083; // LB   X1,X2,1
 riscv.Fetch.IMem.Mem[4]      = 32'h00121183; // LH   X3,X4,1
 riscv.Fetch.IMem.Mem[8]      = 32'h00132283; // LW   X5,X6,1
 riscv.Fetch.IMem.Mem[12]     = 32'h00144383; // LBU  X7,X8,1
 riscv.Fetch.IMem.Mem[16]     = 32'h00155483; // LHU  X9,X10,1
*/
/*
//STORE TYPE
 riscv.Fetch.IMem.Mem[0]     = 32'h00110023; // SB  X2,X1,0
 riscv.Fetch.IMem.Mem[4]     = 32'h00321123; // SH  X4,X3,2
 riscv.Fetch.IMem.Mem[8]     = 32'h005321A3; // SW  X6,X5,3
*/

//REGISTER TYPE
 riscv.Fetch.IMem.Mem[0]     = 32'h00208AB3; // ADD  X21,X1,2
 riscv.Fetch.IMem.Mem[4]     = 32'h40418B33; // SUB  X22,X3,4
 riscv.Fetch.IMem.Mem[8]     = 32'h00629BB3; // SLL  X23,X5,6
 riscv.Fetch.IMem.Mem[12]    = 32'h0083AC33; // SLT  X24,X7,8
 riscv.Fetch.IMem.Mem[16]    = 32'h00A4BCB3; // SLTU X25,X9,10
 riscv.Fetch.IMem.Mem[20]    = 32'h00C5CD33; // XOR  X26,X11,12
 riscv.Fetch.IMem.Mem[24]    = 32'h00E6DDB3; // SRL  X27,X13,14
 riscv.Fetch.IMem.Mem[28]    = 32'h4107DE33; // SRA  X28,X15,16
 riscv.Fetch.IMem.Mem[32]    = 32'h0128EEB3; // OR   X29,X17,18
 riscv.Fetch.IMem.Mem[36]    = 32'h0149FF33; // AND  X30,X19,20


/*
//IMMEDIATE INSTRUCTIONS
 riscv.Fetch.IMem.Mem[0]     = 32'h00108113; // ADDI  X2,X1,1
 riscv.Fetch.IMem.Mem[4]     = 32'h00219213; // SLLI  X4,X3,2
 riscv.Fetch.IMem.Mem[8]     = 32'h0032A313; // SLTI  X6,X5,3
 riscv.Fetch.IMem.Mem[12]    = 32'h8003B413; // SLTUI X8,X7,'h800
 riscv.Fetch.IMem.Mem[16]    = 32'h0054C513; // XORI  X10,X9,5
 riscv.Fetch.IMem.Mem[20]    = 32'h0065D613; // SRLI  X12,X11,6
 riscv.Fetch.IMem.Mem[24]    = 32'h0076D713; // SRAI  X14,X13,7
 riscv.Fetch.IMem.Mem[28]    = 32'h0087E813; // ORI   X16,X15,8
 riscv.Fetch.IMem.Mem[32]    = 32'h0098F913; // ANDI  X18,X17,9
*/
 /*
 riscv.Fetch.IMem.Mem[0]    = 32'h00200193; // ADDI  X3,X0,2
 riscv.Fetch.IMem.Mem[4]    = 32'hFFE00193; // ADDI  X3,X0,-2
*/
 /*
 //control hazard
 riscv.PC_Reg = 10'b0;
 riscv.Instructionmemory.IMem[0]    = 32'h00158693; // ADDI X13, X11,1
 riscv.Instructionmemory.IMem[4]    = 32'h41078733; // SUB  X14, X15, X16
 riscv.Instructionmemory.IMem[8]    = 32'hFE0698E3; // BNE  X13, X0, -8
 // riscv.Instructionmemory.IMem[8]    = 32'h00069063; // BNE  X13, X0, 0
 riscv.Instructionmemory.IMem[12]   = 32'h0128F833; // AND  X16, X17, X18
 riscv.Instructionmemory.IMem[16]   = 32'h015A49B3; // XOR  X19, X20, X21 
 */
 /*
 riscv.PC_Reg = 10'b0;
 riscv.Instructionmemory.IMem[0]    = 32'h00A08113; // ADDI X2, X1,10
 riscv.Instructionmemory.IMem[4]    = 32'h00B18233; // ADD  X4, X3,X11
 riscv.Instructionmemory.IMem[8]    = 32'h00C2E333; // OR   X6, X5,X12
 riscv.Instructionmemory.IMem[12]   = 32'h015822A3; // STORE OPERATION SW  X8, X21, 5
 riscv.Instructionmemory.IMem[16]   = 32'h00A3A403; // LOAD OPERATION LW X8, X7, 10
 riscv.Instructionmemory.IMem[20]   = 32'h00D49533; // SLL  X10, X9, X13
 riscv.Instructionmemory.IMem[24]   = 32'hFEF718E3; // BNE X14, X15,8
 riscv.Instructionmemory.IMem[28]   = 32'h00000013; // ADD1 X0, X0 0
 */
 /*riscv.Instructionmemory.IMem[4]  = 32'h00A18213;
 riscv.Instructionmemory.IMem[8]  = 32'h00A28313;
 riscv.Instructionmemory.IMem[12] = 32'h00A38413;
 riscv.Instructionmemory.IMem[16] = 32'h00A48513;
 riscv.Instructionmemory.IMem[20] = 32'h00A58613;
 riscv.Instructionmemory.IMem[24] = 32'h00000013;
 riscv.Instructionmemory.IMem[28] = 32'h00A18113;
 riscv.Instructionmemory.IMem[32] = 32'h00A10213;
 riscv.Instructionmemory.IMem[36] = 32'h00000013;
 riscv.Instructionmemory.IMem[40] = 32'h00A08113;
 riscv.Instructionmemory.IMem[32] = 32'h00000013;
 riscv.Instructionmemory.IMem[36] = 32'h00000013;
 riscv.Instructionmemory.IMem[40] = 32'h00000013;
 riscv.Instructionmemory.IMem[44] = 32'h00000013;
 riscv.Instructionmemory.IMem[48] = 32'h00000013; 


 riscv.Instructionmemory.IMem[0]   = 32'h00A08113;
 riscv.Instructionmemory.IMem[4]   = 32'h00F18213;
 riscv.Instructionmemory.IMem[8]   = 32'h00B28333;
 riscv.Instructionmemory.IMem[12]  = 32'h40C38433;
 riscv.Instructionmemory.IMem[16]  = 32'h00D4F533;
 */
 end
 initial begin
 #200 $finish;
 end
endmodule