module Sign_Extension(Instruction, Imm);
input [31:0] Instruction;
output [31:0]Imm;

parameter [6:0]r_to_imm = 7'b0010011,
               ld            = 7'b0000011,
               store         = 7'b0100011,
              // upperimm      = 7'b0110111,
              // upperjump     = 7'b1101111,
               branch        = 7'b1100011,
               lui           = 7'b0110111,
               Auipc         = 7'b0010111,
               jal           = 7'b1101111,
               jalr          = 7'b1100111;
               

assign Imm = (Instruction[6:0] == r_to_imm || Instruction[6:0] ==  ld || Instruction[6:0] ==  jalr) ? {{20{Instruction [31]}}, Instruction[31:20]} :
             (Instruction[6:0] == store)    ? {{20{Instruction [31]}}, Instruction[31:25], Instruction [11:7]}:
             (Instruction[6:0] == branch)   ? {{19{Instruction [31]}}, Instruction[31], Instruction [7], Instruction[30:25], Instruction [11:8],1'b0} :
             (Instruction[6:0] == lui || Instruction[6:0] ==  Auipc) ? {Instruction[31:12], {12'b0}} : 
             (Instruction[6:0] == jal) ? {{12{Instruction[31]}}, Instruction[19:12], Instruction[20], Instruction[30:21],1'b0}: 32'b0;
endmodule 